//+------------------------------------------------------------------+
//|                                               CorrelatioPair.mq4 |
//|                                 Copyright  2009, Andrea De Mori |
//|                                         andrea.demori@hotmail.it |
//|                                                                  |
//| Description: Indicatore di correlazione fra 2 pair               |
//+------------------------------------------------------------------+
#property copyright "Andrea De Mori"
#property link      "andrea.demori@hotmail.it"
//----
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Yellow
//----
extern string     OtherChart     = "GBPUSD";
extern int        Points         = 50;
extern bool       UseOpen        = TRUE;
extern bool       UseClose       = FALSE;
extern bool       UseHigh        = FALSE;
extern bool       UseLow         = FALSE;
extern int        CalcBars       = 100;
//----
double Buffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
//---- indicators
   string short_name;
//---- 1 additional buffer used for counting.
   IndicatorBuffers(1);
   IndicatorDigits(Digits);
//---- indicator line
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,Buffer);
   //  SetIndexBuffer(1,TempBuffer);
//---- name for DataWindow and indicator subwindow label
   short_name="Correlation("+Points+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);

   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {

   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {

   int i;
   int k;
   double sx,sy,x,y,cor1,cor2,cor3;

   if (Bars <= Points) 
      return(0);

   if (UseOpen == FALSE && UseClose == FALSE && UseHigh == FALSE && UseLow == FALSE)
      return(0);
      
   for (i=0; i<CalcBars; i++) {
      sx = 0; 
      sy = 0;
      
      for (k=0; k<Points; k++) {
         x = ((Open[i+k]*UseOpen) + (Close[i+k]*UseClose) + (High[i+k]*UseHigh) + (Low[i+k]*UseLow)) / (UseOpen + UseClose + UseHigh + UseLow);
         
         y = ((iOpen(OtherChart,0,i+k)*UseOpen) + (iClose(OtherChart,0,i+k)*UseClose) + (iHigh(OtherChart,0,i+k)*UseHigh) + (iLow(OtherChart,0,i+k)*UseLow)) / (UseOpen + UseClose + UseHigh + UseLow);
            
         sx = sx + x;
         sy = sy + y;
      }
      
      sx = sx / Points;
      sy = sy / Points;      

      cor1 = 0;
      cor2 = 0;
      cor3 = 0;
      
      for (k=0; k<Points; k++) {
         x = ((Open[i+k]*UseOpen) + (Close[i+k]*UseClose) + (High[i+k]*UseHigh) + (Low[i+k]*UseLow)) / (UseOpen + UseClose + UseHigh + UseLow);
            
         y = ((iOpen(OtherChart,0,i+k)*UseOpen) + (iClose(OtherChart,0,i+k)*UseClose) + (iHigh(OtherChart,0,i+k)*UseHigh) + (iLow(OtherChart,0,i+k)*UseLow)) / (UseOpen + UseClose + UseHigh + UseLow);
            
         cor1 = cor1 + ((x-sx)*(y-sy));
         cor2 = cor2 + ((x-sx)*(x-sx));
         cor3 = cor3 + ((y-sy)*(y-sy));
      }

      Buffer[i] = cor1 / MathSqrt(cor2) / MathSqrt(cor3);
   }

   return(0);
}

